--Create a grid(=a 2d-array) with the given width and height and fill each cell with a default value
function createGrid(width, height, fillValue)
	local grid = {}
	for i = 1, width do
		grid[i] = {}
		for j = 1, height do
			grid[i][j] = fillValue
		end
	end
	return grid
end

--get the height of a grid
function getGridHeight(grid)
	local gridHeight = 0
	local value = 0
	while value ~= nil do
		value = grid[1][gridHeight+1]
		gridHeight = gridHeight + 1
	end
	return gridHeight - 1
end

function getGridWidth(grid)
	return table.maxn(cave)
end

--create a grid and fill it randomly with living and death cells
function initialiseCave(caveWidth, caveHeight, chanceToStartAlive)
	local cave = createGrid(caveWidth, caveHeight, 0)
	for x = 1, caveWidth do
		for y = 1, caveHeight do
			if math.random() < chanceToStartAlive then
				cave[x][y] = 1
			end
		end
	end
	return cave
end

--get the living Neighbors of a cell
function countAliveNeighbors(cave, x, y)
	local count = 0
	local neighborX
	local neighborY
	for i = -1, 1 do
		for j = -1, 1 do
			neighborX = x + i
			neighborY = y + j
			if i == 0 and j == 0 then
				--Do nothing
			elseif cave[neighborX][neighborY] == nil then
				count = count + 1
			elseif cave[neighborX][neighborY] == 1 then
				count = count + 1
			end
		end
	end
	return count
end

--simulate a step following a cellular automata ruleset and generate a grid
function simulateStep(cave, deathLimit, birthLimit)
	local caveWidth = getGridWidth(cave)
	local caveHeight = getGridHeight(cave)	
	local caveTemp = cave
	local neighbors
	for x = 1, caveWidth do
		for y = 1, caveHeight do
			neighbors = countAliveNeighbors(cave, x, y)
			if cave[x][y] == 1 then
				if neighbors < deathLimit then
					caveTemp[x][y] = 0
				else
					caveTemp[x][y] = 1
				end
			else
				if neighbors > birthLimit then
					caveTemp[x][y] = 1
				else
					caveTemp[x][y] = 0
				end
			end
		end 
	end
	return caveTemp
end